
void OpenBoxProcedure_BART()
{
//Logit("OpenBoxProcedure_JRH");
//Logit("2222");
	ref chr = GetMainCharacter();
	if( !CheckAttribute(chr,"boxname") ) return;
	int locidx = FindLoadedLocation();
	if(locidx<0) return;
	string atrName = chr.boxname;
	aref ar;
	if(!HasSubStr(chr.boxname,"corpse")){//MAXIMUS: makes box from corpse with hand-icon in the top-left corner -->
		makearef(ar,Locations[locidx].(atrName));
		if(GetAttributesNum(ar)==0)
		{
			Locations[locidx].(atrName).Money = 0;
			makearef(ar,Locations[locidx].(atrName));
		}

    // JRH -->
//-----------------------------------------------------------------------------------------------------------------
	int gp;
	int pb;
	int pg;
	int mb;
	int i;
	//note in INTERFACE\itemsbox search JRH: normal box sounds avoided when not wanted
//pr
    //Cartagena puzzle -->

	if(Locations[locidx].id=="Governor_Daughter_House")
	{
		switch(chr.boxname)
		{
			case "box1":
				LaunchItemsBox(&ar);
			break;

			case "box2":
				if(CheckAttribute(chr,"quest.daughter_fireplace") && chr.quest.daughter_fireplace == "no_key")
				{
					//do nothing

				}
				else
				{
					if(CheckAttribute(chr,"quest.daughter_fireplace") && chr.quest.daughter_fireplace == "key_on_floor")
					{
					

					}
				}
				else
				{
					if(CheckCharacterItem(chr,"bladefire_irons"))
					{
						if(!IsEquipCharacterByItem(chr, "bladefire_irons"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladefire_irons");
						}

						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("use_fire_irons", 1.0);
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_hah.wav");
						Logit(TranslateString("","There's something in the fire."));
					}
				}
			break;
		}

		return;
	}

	if(Locations[locidx].id=="Admiral_Office")
	{
		switch(chr.boxname)
		{
			case "box1":
				//go to chair OR place cannonball

				if(CheckAttribute(chr,"quest.admiral_cannonball") && chr.quest.admiral_cannonball == "placed")
				{
					//do nothing
				}
				else
				{
					if(CheckCharacterItem(chr,"bladecannon_ball"))
					{
						if(!IsEquipCharacterByItem(chr, "bladecannon_ball"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladecannon_ball");
						}

						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("place_admiral_cannonball", 1.0);
					}
					else
					{
						ChangeCharacterAddressGroup(chr, "Admiral_Office", "goto", "sit1");
						chr.quest.admiral_steplock = "way_in";

						LAi_QuestDelay("enter_admiral_steplock", 1.0);
					}
				}
			break;

			case "box2":
				//at chair

				if(CheckAttribute(chr,"quest.admiral_steplock") && chr.quest.admiral_steplock == "way_out")
				{
					LAi_SetPlayerType(chr);
					PlaySound("INTERFACE\step_path.wav");
					Locations[FindLocation("Admiral_Office")].models.always.l1 = "bars_down";

					LAi_QuestDelay("leave_admiral_steplock", 0.3);
				}
			break;

			case "box3":
				//clock

				if(CheckAttribute(chr,"quest.admiral_clock") && chr.quest.admiral_clock == "off")
				{
					chr.quest.admiral_clock = "on";
					LAi_SetStayType(chr);
					PlaySound("INTERFACE\clock_wind_up.wav");

					LAi_QuestDelay("admiral_wind_up_clock", 2.2);
				}
				else
				{
					if(CheckAttribute(chr,"quest.admiral_clock") && chr.quest.admiral_clock == "on")
					{
						//do nothing
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"bladeclockkey"))
					{
						if(!IsEquipCharacterByItem(chr, "bladeclockkey"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladeclockkey");
						}

						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("place_admiral_clockkey", 1.0);
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_hah.wav");
						Logit(TranslateString("","It has stopped."));
					}
				}
			break;
	
			case "box4":
				//lever
				
				if(CheckAttribute(chr,"quest.admiral_lever") && chr.quest.admiral_lever == "down")
				{
					PlaySound("INTERFACE\lever_stuck.wav");
				}
				else
				{
					if(CheckAttribute(chr,"quest.admiral_lever") && chr.quest.admiral_lever == "up")
					{
						chr.quest.admiral_lever = "down";
						PlaySound("INTERFACE\lever_down.wav");
						Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_BoP2";
						Locations[FindLocation("Admiral_Office")].models.always.l2 = "Adm_lever_down";

						LAi_QuestDelay("admiral_lever_down", 1.0);
					}
				}
				else
				{
					//lever is missing
					if(CheckCharacterItem(chr,"bladelever"))
					{
						if(!IsEquipCharacterByItem(chr, "bladelever"))
						{
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								EquipCharacterByItem(chr, "bladelever");
						}

						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("place_admiral_lever", 1.0);
					}
					else PlaySound("VOICE\ENGLISH\blaze_huh.wav");
				}				
			break;

			case "box5":
				//at door to tunnel instead of reload1

				PlaySound("INTERFACE\locked_window.wav");	
			break;
		}

		return;
	}

    //<-- Cartagena puzzle
    // <-- JRH
  }
	//pr
	virtual_box = true;	//JRH
	OpenBoxProcedure();
}

//pr
//from Loginterface.c
void CreateLandActionsEnvironment_BART()
{
//Logit("4444");

	ref PChar = GetMainCharacter();		//JRH

//JRH -->
	if( CheckAttribute(Pchar,"boxname") )
	{
	//	IActions.ActiveActions.OpenBox.IconNum					 	= 29;
	//Cartagena -->
		if(Pchar.location == "Governor_Daughter_House")	
		{
			if(Pchar.boxname == "box2")
			{
				if(CheckCharacterItem(Pchar,"bladefire_irons"))
				{
					IActions.ActiveActions.OpenBox.IconNum  		= 2;	
				}
				else IActions.ActiveActions.OpenBox.IconNum  			= 3;
			}
		}

		if(Pchar.location == "Admiral_office")	
		{
			if(Pchar.boxname == "box1")
			{
				if(CheckCharacterItem(Pchar,"bladecannon_ball"))
				{
					IActions.ActiveActions.OpenBox.IconNum  		= 2;
				}
				else IActions.ActiveActions.OpenBox.IconNum 			= 63;
			}

			if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum 	= 63;

			if(Pchar.boxname == "box3")
			{
				if(CheckAttribute(Pchar,"quest.admiral_clock") && Pchar.quest.admiral_clock == "off")
				{
					IActions.ActiveActions.OpenBox.IconNum 			= 2;
				}
				else
				{
					if(CheckAttribute(Pchar,"quest.admiral_clock") && Pchar.quest.admiral_clock == "on")
						IActions.ActiveActions.OpenBox.IconNum 		= 55;
				}
				else
				{
					if(CheckCharacterItem(Pchar,"bladeclockkey"))
					{
						IActions.ActiveActions.OpenBox.IconNum 		= 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum 		= 55;
				}
			}

			if(Pchar.boxname == "box4")
			{
				if(CheckAttribute(Pchar,"quest.admiral_lever"))  
				{
					if(Pchar.quest.admiral_lever == "down" || Pchar.quest.admiral_lever == "up")
					{
						IActions.ActiveActions.OpenBox.IconNum  	= 2;
					}
				}
				else
				{
					if(CheckCharacterItem(Pchar,"bladelever"))
					{
						IActions.ActiveActions.OpenBox.IconNum  = 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum  	= 3;
				}					
			}

			if(Pchar.boxname == "box5") IActions.ActiveActions.OpenBox.IconNum 	= 2;
		}   
	//<-- Cartagena
   }
//<-- JRH
}
